/*
    UUID Decode - Displays Properties of UUIDs
    Copyright 2014,2015 Harry Whitfield

    This program is free software; you can redistribute it and/or modify it under
    the terms of the GNU General Public License as published by the Free Software
    Foundation; either version 2 of the License, or (at your option) any later
    version.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY
    WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
    PARTICULAR PURPOSE.  See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with
    this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
    St, Fifth Floor, Boston, MA  02110-1301  USA

    UUID Decode - browser version 1.0
    5 May, 2015
    Copyright 2014,2015 Harry Whitfield
    mailto:g6auc@arrl.net
 */

/*jslint browser */

/*global newImage, newInput, newText, newSelector, addToMenu, moveObj, scale, fScale,
    alert, window
*/

/*properties
    backgroundColor, border, clientX, close, hOffset, length, maxWidth, onclick,
    onmousedown, onmousemove, onmouseout, onmouseover, onmouseup, opacity, open,
    round, selectedIndex, setStyle, size, src, style, title, tracking, value,
    width
*/

//////////////////////////// Start of the calculator skeleton ////////////////////////////

//  mainWindow.width = Math.round(scale * 280);
//  mainWindow.height = Math.round(scale * 318);

// newImage(hOffset, vOffset, width, height, src, zOrder, opacity)
// newText(hOffset, vOffset, width, height, value, zOrder, style)
// newTextArea(hOffset, vOffset, cols, rows, value, zOrder, style)
// newInput(hOffset, vOffset, width, height, value, zOrder, style)
// newCanvas(hOffset, vOffset, width, height, src, zOrder, opacity, hRegP, vRegP)
// newSelector(hOffset, vOffset, width, height, src, zOrder, opacity)

var base = "Resources/bkgd/";

var leftTop = newImage(0, 0, 40, 40, base + "bgleftTop.png", 1);
var leftMid = newImage(0, 40, 40, 225, base + "bgleftMid.png", 1);
var leftLow = newImage(0, 265, 40, 53, base + "bgleftLow.png", 1);

var middleTop = newImage(40, 0, 200, 40, base + "bgmiddleTop.png", 1);
var middleMid = newImage(40, 40, 200, 225, base + "bgmiddleMid.png", 1);
var middleLow = newImage(40, 265, 200, 53, base + "bgmiddleLow.png", 1);

var rightTop = newImage(240, 0, 40, 40, base + "bgrightTop.png", 1);
var rightMid = newImage(240, 40, 40, 225, base + "bgrightMid.png", 1);
var rightLow = newImage(240, 265, 40, 53, base + "bgrightLow.png", 1);

var dragbox = newImage(238, 271, 20, 20, base + "dragbox.png", 2);
dragbox.tracking = "rectangle";
dragbox.title = "Click to enable - move over me to change the widget's width - click again to disable.";

base = "Resources/buttons/";

var redButton = newImage(28, 21, 21, 14, base + "red.png", 2);
var amberButton = newImage(49, 21, 21, 14, base + "amber.png", 2);
var greenButton = newImage(70, 21, 14, 14, base + "green.png", 2);

var helpButton = newImage(440, 16, 30, 22, base + "help.png", 2);   // customized

redButton.title = "Click to close the Widget.";
amberButton.title = "Click to clear the data fields.";
greenButton.title = "Click to toggle the window size.";

helpButton.title = "Displays information about this program.";

var style = "background-color:transparent;border:none;font-size:12px;";

var title = newText(88, 18, 70, 16, "UUID Decode", 2, style);               // customized

base = "Resources/boxes/";

var leftBgOne = newImage(28, 44, 18, 39, base + "tbleft.png", 2);
var midBgOne = newImage(46, 44, 188, 39, base + "tbmiddle.png", 2);
var rightBgOne = newImage(234, 44, 18, 39, base + "tbright.png", 2);

var leftBgTwo = newImage(28, 100, 18, 39, base + "tbleft.png", 2);
var midBgTwo = newImage(46, 100, 188, 39, base + "tbmiddle.png", 2);
var rightBgTwo = newImage(234, 100, 18, 39, base + "tbright.png", 2);

var leftBgThree = newImage(28, 156, 18, 39, base + "tbleft.png", 2);
var midBgThree = newImage(46, 156, 188, 39, base + "tbmiddle.png", 2);
var rightBgThree = newImage(234, 156, 18, 39, base + "tbright.png", 2);

var leftBgFour = newImage(28, 212, 18, 39, base + "tbleft.png", 2);
var midBgFour = newImage(46, 212, 188, 39, base + "tbmiddle.png", 2);
var rightBgFour = newImage(234, 212, 18, 39, base + "tbright.png", 2);

style = "font-family:'Lucida Grande','Lucida Sans Unicode';font-weight:bold;font-size:14px;text-align:center;border:none";  // set fScale to 6.0

var paramOne = newInput(39, 53, 200, 20, "d08d0f10-faca-11e3-87d2-ec358632f67c", 3, style); // customized
var paramTwo = newInput(39, 109, 200, 20, "Mon, 23 Jun 2014 11:37:54 GMT +49mS", 3, style); // customized
var paramThree = newInput(39, 165, 200, 20, "1 (8:X.667)", 3, style);  // customized
var paramFour = newInput(39, 221, 200, 20, "", 3, style);  // customized

//  paramOne.style.background = "rgba(192 ,192, 192, 1.0)";

paramOne.title = "Enter an UUID into this box.";    // customized
paramTwo.title = "UUID Creation Time.";         // customized
paramThree.title = "UUID Version (variant).";       // customized
paramFour.title = "";                               // customized

style = "background-color:transparent;border:none;font-size:12px;";

var headingOne = newText(36, 74, 40, 16, "UUID", 2, style); // customized
var headingTwo = newText(36, 130, 120, 16, "UUID Creation Time", 2, style); // customized
var headingThree = newText(36, 186, 130, 16, "UUID Version (variant)", 2, style);   // customized
var headingFour = newText(36, 242, 60, 16, "Message", 2, style);  // customized

//////////////////////////////////// Menus Customized ////////////////////////////////////

var MenuArray = [
    ["X.667 only", "X.667 and NCS", "X.667 and Microsoft", "X.667, NCS and Microsoft"],
    ["Local Time", "Use Universal Time"],
    ["12-hour", "24-hour"]
];

var MenuTitleArray = [
    "Choose the UUID variants that may be imported.",
    "Choose how timestamps are to be displayed.",
    "Choose the time format required."
];

var MenuSelectedIndex = [0, 1, 1];

var Menu = [];

Menu[0] = newSelector(200, 17, 110, 20, "", 2);
Menu[1] = newSelector(300, 80, 56, 20, "", 2);
Menu[2] = newSelector(200, 80, 110, 20, "", 2);

(function () {
    "use strict";
    MenuArray.forEach(function (ele, i) {
        addToMenu(Menu[i], ele);
        Menu[i].selectedIndex = MenuSelectedIndex[i];
        Menu[i].title = MenuTitleArray[i];
    });
}());

//////////////////////////////////////////////////////////////////////////////////////////

var print = function (s) {
    "use strict";
    alert(s);
};
var debug = false;
var minWidth = 275;     // customized
var maxWidth = 500;     // customized
var curWidth = maxWidth;
var dragEnabled = false;

function setUp(width) {
    "use strict";
    if (debug) {
        print("setUp():======== start ========:");
        print("width=" + width);
        print("minWidth=" + minWidth);
        print("maxWidth=" + maxWidth);
    }

    if (width < minWidth) {
        width = minWidth;
    }
    if (width > maxWidth) {
        width = maxWidth;
    }

//  main_window.width = width;

    middleTop.width = width - 80;
    middleMid.width = width - 80;
    middleLow.width = width - 80;

    rightTop.hOffset = width - 40;
    moveObj(rightTop, width - 40, 0);
    moveObj(rightMid, width - 40, 40);
    moveObj(rightLow, width - 40, 265);

    midBgOne.width = width - 92;
    midBgTwo.width = width - 92;
    midBgThree.width = width - 92;
    midBgFour.width = width - 92;

    moveObj(rightBgOne, width - 46, 44);
    moveObj(rightBgTwo, width - 46, 100);
    moveObj(rightBgThree, width - 46, 156);
    moveObj(rightBgFour, width - 46, 212);

    dragbox.hOffset = width - 42;
    moveObj(dragbox, width - 42, 271);

    paramOne.width = Math.round(scale * (width - 80));
    paramTwo.width = paramOne.width;
    paramThree.width = paramOne.width;
    paramFour.width = paramOne.width;

    paramOne.size = Math.round(scale * (width - 84) / fScale);
    paramTwo.size = paramOne.size;
    paramThree.size = paramOne.size;
    paramFour.size = paramOne.size;

    paramOne.style.maxWidth = Math.round(scale * (width - 84)) + "px";
    paramTwo.style.maxWidth = paramOne.style.maxWidth;
    paramThree.style.maxWidth = paramOne.style.maxWidth;
    paramFour.style.maxWidth = paramOne.style.maxWidth;

    if (debug) {
        print("width=" + width);

//      print('main_window.width=' + main_window.width);
        print("middleTop.width=" + middleTop.width);
        print("rightTop.hOffset=" + rightTop.hOffset);
        print("paramOne.width=" + paramOne.width);
        print("dragbox.hOffset=" + dragbox.hOffset);

        print("setUp():========  end ========:");
    }

    return width;
}

//////////////////////////////////////////////////////////////////////////////////////////

dragbox.onclick = function () {
    "use strict";
    dragEnabled = !dragEnabled;
    if (dragEnabled) {
        MenuArray.forEach(function (ignore, i) {
            Menu[i].style.opacity = 0.0;
        });
        helpButton.style.opacity = 0.0;

    } else {
        if (curWidth === maxWidth) {
            MenuArray.forEach(function (ignore, i) {
                Menu[i].style.opacity = 1.0;
            });
            helpButton.style.opacity = 1.0;
        }
    }
};

dragbox.onmousemove = function (event) {
    "use strict";
    if (dragEnabled) {
        moveObj(dragbox, event.clientX - 10, 271);
        curWidth = setUp(event.clientX - 10 + 42);
    }
};

//////////////////////////////////////////////////////////////////////////////////////////

function normalButtons() {
    "use strict";
    var base1 = "Resources/buttons/";

    redButton.src = base1 + "red.png";
    amberButton.src = base1 + "amber.png";
    greenButton.src = base1 + "green.png";
}

function activeButtons() {
    "use strict";
    var base1 = "Resources/buttons/";

    redButton.src = base1 + "redCross.png";
    amberButton.src = base1 + "amberMinus.png";
    greenButton.src = base1 + "greenPlus.png";
}

redButton.onmouseover = function () {
    "use strict";
    activeButtons();
};

redButton.onmouseout = function () {
    "use strict";
    normalButtons();
};

amberButton.onmouseover = function () {
    "use strict";
    activeButtons();
};

amberButton.onmouseout = function () {
    "use strict";
    normalButtons();
};

greenButton.onmouseover = function () {
    "use strict";
    activeButtons();
};

greenButton.onmouseout = function () {
    "use strict";
    normalButtons();
};

redButton.onclick = function () {
    "use strict";
    window.close();
};

function clearData() {
    "use strict";
    paramOne.value = "";
    paramTwo.value = "";
    paramThree.value = "";
    paramFour.value = "";
}

amberButton.onclick = function () {
    "use strict";
    clearData();
};

greenButton.onclick = function () {
    "use strict";
    dragEnabled = false;

    if (curWidth === minWidth) {
        curWidth = setUp(maxWidth);
        MenuArray.forEach(function (ignore, i) {
            Menu[i].style.opacity = 1.0;
        });
        helpButton.style.opacity = 1.0;
    } else {
        curWidth = setUp(minWidth);
        MenuArray.forEach(function (ignore, i) {
            Menu[i].style.opacity = 0.0;
        });
        helpButton.style.opacity = 0.0;
    }
};

//////////////////////////////////////////////////////////////////////////////////////////

helpButton.onmousedown = function () {
    "use strict";
    helpButton.style.opacity = "0.5";
};
helpButton.onmouseup = function () {
    "use strict";
    helpButton.style.opacity = "1.0";
    window.open("Help.html");
};

setUp(maxWidth);

//////////////////////////////////////////////////////////////////////////////////////////

